> ## Documentation Index
> Fetch the complete documentation index at: https://docs.fermion.app/llms.txt
> Use this file to discover all available pages before exploring further.

# Get presigned URL for downloadable product upload 

> Generate a presigned URL to upload files for a downloadable product

Authentication with the "FERMION-API-KEY" header is required to use this endpoint.

Rate limit: Maximum 60 requests in a window of 1m.



## OpenAPI

````yaml https://backend.codedamn.com/webhook/fermion-backend-openapi.yaml post /public/get-presigned-url-for-downloadable-product-upload
openapi: 3.0.0
info:
  version: 1.0.0
  title: Fermion Backend API
  description: Documentation for interacting with the Fermion API
  contact:
    name: Fermion Support
    email: support@codedamn.com
servers:
  - url: https://backend.codedamn.com/api
    description: Fermion primary backend server
security: []
externalDocs:
  description: Fermion Docs
  url: https://docs.fermion.app
paths:
  /public/get-presigned-url-for-downloadable-product-upload:
    post:
      tags:
        - Product
      summary: 'Get presigned URL for downloadable product upload '
      description: >-
        Generate a presigned URL to upload files for a downloadable product


        Authentication with the "FERMION-API-KEY" header is required to use this
        endpoint.


        Rate limit: Maximum 60 requests in a window of 1m.
      requestBody:
        description: API Request Body
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                data:
                  type: array
                  items:
                    type: object
                    properties:
                      data:
                        type: object
                        properties:
                          productSlug:
                            type: string
                            minLength: 1
                            description: >-
                              Slug of the downloadable product returned from
                              create-downloadable-product
                          fileNameWithExtension:
                            type: string
                            minLength: 1
                            description: >-
                              Filename with extension for the file to upload
                              (e.g., "my-file.pdf", "archive.zip",
                              "document.docx")
                        required:
                          - productSlug
                          - fileNameWithExtension
                    required:
                      - data
              required:
                - data
      responses:
        '200':
          description: API Response Body
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  properties:
                    output:
                      anyOf:
                        - type: object
                          properties:
                            status:
                              type: string
                              enum:
                                - ok
                            data:
                              type: object
                              properties:
                                r2KeyForOriginalDownloadableProductPdf:
                                  type: string
                                  description: >-
                                    R2/S3 key for the uploaded file. Use this in
                                    the process-uploaded-downloadable-product
                                    API call after uploading.
                                presignedUrl:
                                  type: string
                                  format: uri
                                  description: >-
                                    Presigned URL for uploading the file. Make a
                                    PUT request to this URL with the file as the
                                    body. URL expires in 1 hour.
                              required:
                                - r2KeyForOriginalDownloadableProductPdf
                                - presignedUrl
                          required:
                            - status
                            - data
                        - type: object
                          properties:
                            status:
                              type: string
                              enum:
                                - error
                            errorMessage:
                              type: string
                          required:
                            - status
                            - errorMessage
                  required:
                    - output
      security:
        - FERMION-API-KEY: []
components:
  securitySchemes:
    FERMION-API-KEY:
      name: FERMION-API-KEY
      type: apiKey
      in: header

````